package com.ruoyi.web.controller.system;

import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletResponse;

import com.ruoyi.system.domain.UserInfo;
import com.ruoyi.system.domain.dto.BackstageUserDto;
import com.ruoyi.system.domain.vo.UserManagerVo;
import com.ruoyi.system.service.*;
import org.apache.commons.lang3.ArrayUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.domain.entity.SysDept;
import com.ruoyi.common.core.domain.entity.SysRole;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.poi.ExcelUtil;

/**
 * 用户信息
 * 
 * @author ruoyi
 */
@RestController
@RequestMapping("/system/user")
public class SysUserController extends BaseController
{
    @Autowired
    private ISysUserService userService;

    @Autowired
    private ISysRoleService roleService;

    @Autowired
    private ISysDeptService deptService;

    @Autowired
    private ISysPostService postService;

    @Autowired
    private IUserInfoService userInfoService;

//    @Autowired
//    private ISysUserRo



    /**
     * 获取用户列表
     */
    @PreAuthorize("@ss.hasPermi('system:user:list')")
    @GetMapping("/list")
    public TableDataInfo list(SysUser user)
    {
        startPage();
        List<SysUser> list = userService.selectUserList(user);
        return getDataTable(list);
    }

//    /*
//    * 新版获取后台用户列表
//    * */
//    @PreAuthorize("@ss.hasPermi('system:user:list')")
//    @GetMapping("/backlist")
//    public TableDataInfo backlist(SysUser user)
//    {
//        startPage();
//        List<UserManagerVo> list = userService.getBackstageUserList();
//        return getDataTable(list);
//    }
//    /*
//    * 新版根据id获取用户账号信息
//    * */
//    @PreAuthorize("@ss.hasPermi('system:user:query')")
//    @GetMapping("/back/{userId}")
//    public AjaxResult getBackUserInfo(@PathVariable("userId") Long userId)
//    {
//
//        UserManagerVo userManagerVo = userService.getBackstageUserById(userId);
//        return success(userManagerVo);
//    }

    @Log(title = "用户管理", businessType = BusinessType.EXPORT)
    @PreAuthorize("@ss.hasPermi('system:user:export')")
    @PostMapping("/export")
    public void export(HttpServletResponse response, SysUser user)
    {
        List<SysUser> list = userService.selectUserList(user);
        ExcelUtil<SysUser> util = new ExcelUtil<SysUser>(SysUser.class);
        util.exportExcel(response, list, "用户数据");
    }

    @Log(title = "用户管理", businessType = BusinessType.IMPORT)
    @PreAuthorize("@ss.hasPermi('system:user:import')")
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file, boolean updateSupport) throws Exception
    {
        ExcelUtil<SysUser> util = new ExcelUtil<SysUser>(SysUser.class);
        List<SysUser> userList = util.importExcel(file.getInputStream());
        String operName = getUsername();
        String message = userService.importUser(userList, updateSupport, operName);
        return success(message);
    }

    @PostMapping("/importTemplate")
    public void importTemplate(HttpServletResponse response)
    {
        ExcelUtil<SysUser> util = new ExcelUtil<SysUser>(SysUser.class);
        util.importTemplateExcel(response, "用户数据");
    }

    /**
     * 根据用户编号获取详细信息
     */
    @PreAuthorize("@ss.hasPermi('system:user:query')")
    @GetMapping(value = { "/", "/{userId}" })
    public AjaxResult getInfo(@PathVariable(value = "userId", required = false) Long userId)
    {
        userService.checkUserDataScope(userId);
        AjaxResult ajax = AjaxResult.success();
        List<SysRole> roles = roleService.selectRoleAll();
        ajax.put("roles", SysUser.isAdmin(userId) ? roles : roles.stream().filter(r -> !r.isAdmin()).collect(Collectors.toList()));
        ajax.put("posts", postService.selectPostAll());
        if (StringUtils.isNotNull(userId))
        {
            SysUser sysUser = userService.selectUserById(userId);
            ajax.put(AjaxResult.DATA_TAG, sysUser);
            ajax.put("postIds", postService.selectPostListByUserId(userId));
            ajax.put("roleIds", sysUser.getRoles().stream().map(SysRole::getRoleId).collect(Collectors.toList()));
        }
        return ajax;
    }

    /**
     * 新增用户
     */
    @PreAuthorize("@ss.hasPermi('system:user:add')")
    @Log(title = "用户管理", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@Validated @RequestBody SysUser user)
    {
        if (!userService.checkUserNameUnique(user))
        {
            return error("新增用户'" + user.getUserName() + "'失败，登录账号已存在");
        }
        else if (StringUtils.isNotEmpty(user.getPhonenumber()) && !userService.checkPhoneUnique(user))
        {
            return error("新增用户'" + user.getUserName() + "'失败，手机号码已存在");
        }
        else if (StringUtils.isNotEmpty(user.getEmail()) && !userService.checkEmailUnique(user))
        {
            return error("新增用户'" + user.getUserName() + "'失败，邮箱账号已存在");
        }
        user.setCreateBy(getUsername());
        user.setPassword(SecurityUtils.encryptPassword(user.getPassword()));
        return toAjax(userService.insertUser(user));
    }

//    /*
//    * 新版新增用户
//    * */
//
//    @PreAuthorize("@ss.hasPermi('system:user:add')")
//    @Transactional
//    @Log(title = "用户管理", businessType = BusinessType.INSERT)
//    @PostMapping("/createBackstageUser")
//    public AjaxResult createBackstageUser(@RequestBody BackstageUserDto backstageUserDto){
//
//            String nickName = backstageUserDto.getNickName();
//            String phone = backstageUserDto.getPhone();
//            String realName = backstageUserDto.getRealName();
//            String status = backstageUserDto.getStatus();
//            // 用户角色
//            String userRole = backstageUserDto.getUserRole();
//            String password = backstageUserDto.getPassword();
//
//            if(password == null){
//                password = "dafds81364dsk";
//            }
//
//            //先验证手机号是否已经注册
//            int i = userService.checkUserPhone(phone);
//            if (i > 0) {
//                return error("该手机号已经注册");
//            }
//
//            SysUser sysUser = new SysUser();
//            sysUser.setNickName(nickName);
//            sysUser.setPhonenumber(phone);
//            sysUser.setStatus(status);
//            sysUser.setUserType("0000000001");
//            sysUser.setUserName(phone);
//            sysUser.setAvatar("https://gips0.baidu.com/it/u=3124792457,2870658645&fm=3039&app=3039&f=JPEG");
//            sysUser.setPassword(SecurityUtils.encryptPassword(password));
//
//            UserInfo userInfo = new UserInfo();
//
//
//            int back = userService.insertUser(sysUser);
//
//            if (back > 0){
//                System.out.println(nickName+","+phone+","+realName+","+status+","+userRole);
//
//                // 查询数据库中的用户账号信息
//                SysUser newSysUser = userService.selectUserByUserName(phone);
//                Long userId = newSysUser.getUserId();
//
//                //---------------------------- 新建用户个人信息--------------------------------------------
//                userInfo.setUserId(userId);
//                userInfo.setRealName(realName);
//                userInfo.setPhonenumber(phone);
//                userInfo.setBackGround("https://img.keaitupian.cn/newupload/11/1668068437206545.jpg");
//                // 获取当前时间的毫秒值
//                long currentTimeMillis = System.currentTimeMillis();
//                // 利用毫秒值构造Date对象
//                Date currentDate = new Date(currentTimeMillis);
//                userInfo.setUpdateTime(currentDate);
//
//                //设置上一次计算时间大约为10天前
//                Date calculationTime = new Date(currentTimeMillis-1000000000);
//                userInfo.setCalculationTime(calculationTime);
//
//                int infoFlag = userInfoService.insertUserInfo(userInfo);
//                if (infoFlag == 0) {
//                    return error("个人信息注册失败,请联系系统管理人员");
//                }
//                //-------------------------------新建用户个人信息结束----------------------------------------
//
//                //---------------------------------给新用户分配角色------------------------------------------
//                SysRole role = new SysRole();
//                role.setRoleName(userRole);
//
//                List<SysRole> roles = roleService.selectRoleList(role);
//                if (roles.size() == 0) {
//                    return error("该角色不存在,请联系管理员");
//                }
//                // 这里默认一个角色名对应一个角色
//                SysRole sysRole = roles.get(0);
//
//                // 角色id
//                Long roleId = sysRole.getRoleId();
//
//
//                //写入用户角色表
//                int roleFlag = roleService.insertSysUserRole(userId,roleId);
//
//                if (roleFlag == 0) {
//                    return error("用户角色分配失败,请联系管理员");
//                }
//
//                //---------------------------------给新用户分配角色结束--------------------------------------
//
//
//
//
//
//                return success("新建用户成功");
//            }
//
//            return error("新建用户失败, 请联系管理员");
//    }

//    /*
//    * 新版修改用户
//    * */
//    @PreAuthorize("@ss.hasPermi('system:user:edit')")
//    @Log(title = "用户管理", businessType = BusinessType.UPDATE)
//    @PutMapping("/updateBackstageUser")
//    public AjaxResult updateBackstageUser(@RequestBody BackstageUserDto backstageUserDto){
//
//        Long userId = backstageUserDto.getUserId();
//        String userRole = backstageUserDto.getUserRole();
//        String userStatus = backstageUserDto.getStatus();
//
//        //---------------------------------------修改用户角色-------------------------------------------------
//        // 根据角色名查角色id
//        Long roleId = roleService.selectRoleIdByRoleName(userRole);
//        int roleFlag = roleService.updateUserRole(userId, roleId);
//
//        if(roleFlag == 0){
//            return error("修改用户角色失败,请联系管理员");
//        }
//        //--------------------------------------修改用户角色结束----------------------------------------------
//
//        //修改用户状态
//        SysUser sysUser = new SysUser();
//        sysUser.setUserId(userId);
//        sysUser.setStatus(userStatus);
//        int statusFlag = userService.updateUserStatus(sysUser);
//        if (statusFlag == 0){
//            return error("修改用户状态失败,请联系管理员");
//        }
//
//        return success("修改用户账号信息成功");
//    }



    /**
     * 修改用户
     */
    @PreAuthorize("@ss.hasPermi('system:user:edit')")
    @Log(title = "用户管理", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysUser user)
    {
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());
        if (!userService.checkUserNameUnique(user))
        {
            return error("修改用户'" + user.getUserName() + "'失败，登录账号已存在");
        }
        else if (StringUtils.isNotEmpty(user.getPhonenumber()) && !userService.checkPhoneUnique(user))
        {
            return error("修改用户'" + user.getUserName() + "'失败，手机号码已存在");
        }
        else if (StringUtils.isNotEmpty(user.getEmail()) && !userService.checkEmailUnique(user))
        {
            return error("修改用户'" + user.getUserName() + "'失败，邮箱账号已存在");
        }
        user.setUpdateBy(getUsername());
        return toAjax(userService.updateUser(user));
    }

//    /*
//    * 新版删除用户
//    * */
//    @PreAuthorize("@ss.hasPermi('system:user:remove')")
//    @Log(title = "系统管理--人员管理--删除后台用户", businessType = BusinessType.DELETE)
//    // 删除后台用户
//    @DeleteMapping("/deleteUser/{userId}")
//    public AjaxResult deleteBackstageUser(@PathVariable Long userId){
//
//        int back = userService.deleteUserById(userId);
//        if(back > 0){
//            return success("删除用户成功");
//        }
//        return error("删除用户失败");
//
//    }

    /**
     * 删除用户
     */
    @PreAuthorize("@ss.hasPermi('system:user:remove')")
    @Log(title = "用户管理", businessType = BusinessType.DELETE)
    @DeleteMapping("/{userIds}")
    public AjaxResult remove(@PathVariable Long[] userIds)
    {
        if (ArrayUtils.contains(userIds, getUserId()))
        {
            return error("当前用户不能删除");
        }
        return toAjax(userService.deleteUserByIds(userIds));
    }

    /**
     * 重置密码
     */
    @PreAuthorize("@ss.hasPermi('system:user:resetPwd')")
    @Log(title = "用户管理", businessType = BusinessType.UPDATE)
    @PutMapping("/resetPwd")
    public AjaxResult resetPwd(@RequestBody SysUser user)
    {
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());
        user.setPassword(SecurityUtils.encryptPassword(user.getPassword()));
        user.setUpdateBy(getUsername());
        return toAjax(userService.resetPwd(user));
    }

    /**
     * 状态修改
     */
    @PreAuthorize("@ss.hasPermi('system:user:edit')")
    @Log(title = "用户管理", businessType = BusinessType.UPDATE)
    @PutMapping("/changeStatus")
    public AjaxResult changeStatus(@RequestBody SysUser user)
    {
        userService.checkUserAllowed(user);
        userService.checkUserDataScope(user.getUserId());
        user.setUpdateBy(getUsername());
        return toAjax(userService.updateUserStatus(user));
    }

    /**
     * 根据用户编号获取授权角色
     */
    @PreAuthorize("@ss.hasPermi('system:user:query')")
    @GetMapping("/authRole/{userId}")
    public AjaxResult authRole(@PathVariable("userId") Long userId)
    {
        AjaxResult ajax = AjaxResult.success();
        SysUser user = userService.selectUserById(userId);
        List<SysRole> roles = roleService.selectRolesByUserId(userId);
        ajax.put("user", user);
        ajax.put("roles", SysUser.isAdmin(userId) ? roles : roles.stream().filter(r -> !r.isAdmin()).collect(Collectors.toList()));
        return ajax;
    }

    /**
     * 用户授权角色
     */
    @PreAuthorize("@ss.hasPermi('system:user:edit')")
    @Log(title = "用户管理", businessType = BusinessType.GRANT)
    @PutMapping("/authRole")
    public AjaxResult insertAuthRole(Long userId, Long[] roleIds)
    {
        userService.checkUserDataScope(userId);
        userService.insertUserAuth(userId, roleIds);
        return success();
    }

    /**
     * 获取部门树列表
     */
    @PreAuthorize("@ss.hasPermi('system:user:list')")
    @GetMapping("/deptTree")
    public AjaxResult deptTree(SysDept dept)
    {
        return success(deptService.selectDeptTreeList(dept));
    }
}
